import { Session } from 'koishi';
import { Observable } from 'rxjs';

export function sessionRxToPromise(session: Session, obs: Observable<string>) {
  return new Promise<string>((resolve, reject) => {
    let lastValue: string;
    obs.subscribe({
      next: async (value) => {
        if (lastValue && session.send) {
          await session.send(lastValue);
        }
        lastValue = value;
      },
      error: async (error) => {
        if (lastValue && session.send) {
          await session.send(lastValue);
        }
        reject(error);
      },
      complete: () => {
        resolve(lastValue);
      },
    });
  });
}
